---
title: Basic shapes
slug: Web/SVG/Tutorial/Basic_Shapes
tags:
  - Beginner
  - SVG
  - 'SVG:Tutorial'
---
<p>{{ PreviousNext("Web/SVG/Tutorial/Positions", "Web/SVG/Tutorial/Paths") }}</p>

<p>There are several basic shapes used for most SVG drawing. The purpose of these shapes is fairly obvious from their names. Some of the parameters that determine their position and size are given, but an element reference would probably contain more accurate and complete descriptions along with other properties that won't be covered in here. However, since they're used in most SVG documents, it's necessary to give them some sort of introduction.</p>

<h2 id="Basic_shapes">Basic shapes</h2>

<p>To insert a shape, you create an element in the document. Different elements correspond to different shapes and take different parameters to describe the size and position of those shapes. Some are slightly redundant in that they can be created by other shapes, but they're all there for your convenience and to keep your SVG documents as short and as readable as possible. All the basic shapes are shown in the image to the right. The code to generate that looks something like:</p>

<p><img alt="" class="internal" src="/@api/deki/files/359/=Shapes.png" style="float: right;"></p>

<pre class="brush:xml">&lt;?xml version="1.0" standalone="no"?&gt;
&lt;svg width="200" height="250" version="1.1" xmlns="http://www.w3.org/2000/svg"&gt;

  &lt;rect x="10" y="10" width="30" height="30" stroke="black" fill="transparent" stroke-width="5"/&gt;
  &lt;rect x="60" y="10" rx="10" ry="10" width="30" height="30" stroke="black" fill="transparent" stroke-width="5"/&gt;

  &lt;circle cx="25" cy="75" r="20" stroke="red" fill="transparent" stroke-width="5"/&gt;
  &lt;ellipse cx="75" cy="75" rx="20" ry="5" stroke="red" fill="transparent" stroke-width="5"/&gt;

  &lt;line x1="10" x2="50" y1="110" y2="150" stroke="orange" stroke-width="5"/&gt;
  &lt;polyline points="60 110 65 120 70 115 75 130 80 125 85 140 90 135 95 150 100 145"
      stroke="orange" fill="transparent" stroke-width="5"/&gt;

  &lt;polygon points="50 160 55 180 70 180 60 190 65 205 50 195 35 205 40 190 30 180 45 180"
      stroke="green" fill="transparent" stroke-width="5"/&gt;

  &lt;path d="M20,230 Q40,205 50,230 T90,230" fill="none" stroke="blue" stroke-width="5"/&gt;
&lt;/svg&gt;</pre>

<div class="note"><strong>Note:</strong> The <code>stroke</code>, <code>stroke-width</code>, and <code>fill</code> attributes are explained later in the tutorial.</div>

<h3 id="Rectangles">Rectangle</h3>

<p>The {{SVGElement("rect")}} element draws a rectangle on the screen. There are 6 basic attributes that control the position and shape of the rectangles on screen. The one on the right has its <code>rx</code> and <code>ry</code> parameters set, giving it rounded corners. If they're not set, they default to <code>0</code>.</p>

<pre class="brush:xml">&lt;rect x="10" y="10" width="30" height="30"/&gt;
&lt;rect x="60" y="10" rx="10" ry="10" width="30" height="30"/&gt;</pre>

<dl>
 <dt><code>x</code></dt>
 <dd>The x position of the top left corner of the rectangle.</dd>
 <dt><code>y</code></dt>
 <dd>The y position of the top left corner of the rectangle.</dd>
 <dt><code>width</code></dt>
 <dd>The width of the rectangle</dd>
 <dt><code>height</code></dt>
 <dd>The height of the rectangle</dd>
 <dt><code>rx</code></dt>
 <dd>The x radius of the corners of the rectangle</dd>
 <dt><code>ry</code></dt>
 <dd>The y radius of the corners of the rectangle</dd>
</dl>

<h3 id="Circle">Circle</h3>

<p>The {{SVGElement("circle")}} element draws a circle on the screen. It takes 3 basic parameters to determine the shape and size of the element.</p>

<pre class="brush:xml;gutter:false;">&lt;circle cx="25" cy="75" r="20"/&gt;</pre>

<dl>
 <dt><code>r</code></dt>
 <dd>The radius of the circle.</dd>
 <dt><code>cx</code></dt>
 <dd>The x position of the center of the circle.</dd>
 <dt><code>cy</code></dt>
 <dd>The y position of the center of the circle.</dd>
</dl>

<h3 id="Ellipse">Ellipse</h3>

<p>An {{SVGElement("ellipse")}} is a more general form of the {{SVGElement("circle")}} element, where you can scale the x and y radius (commonly refferred to as the <em>semimajor</em> and <em>semiminor</em> axes in maths) of the circle separately.</p>

<pre class="brush:xml;gutter:false;">&lt;ellipse cx="75" cy="75" rx="20" ry="5"/&gt;</pre>

<dl>
 <dt><code>rx</code></dt>
 <dd>The x radius of the ellipse.</dd>
 <dt><code>ry</code></dt>
 <dd>The y radius of the ellipse.</dd>
 <dt><code>cx</code></dt>
 <dd>The x position of the center of the ellipse.</dd>
 <dt><code>cy</code></dt>
 <dd>The y position of the center of the ellipse.</dd>
</dl>

<h3 id="Line">Line</h3>

<p>The {{SVGElement("line")}} element takes the positions of two points as parameters and draws a straight line between them.</p>

<pre class="brush:xml;gutter:false;">&lt;line x1="10" x2="50" y1="110" y2="150"/&gt;</pre>

<dl>
 <dt><code>x1</code></dt>
 <dd>The x position of point 1.</dd>
 <dt><code>y1</code></dt>
 <dd>The y position of point 1.</dd>
 <dt><code>x2</code></dt>
 <dd>The x position of point 2.</dd>
 <dt><code>y2</code></dt>
 <dd>The y position of point 2.</dd>
</dl>

<h3 id="Polyline">Polyline</h3>

<p>A {{SVGElement("polyline")}} is a group of connected straight lines. Since the list of points can get quite long, all the points are included in one attribute:</p>

<pre class="brush:xml;gutter:false;">&lt;polyline points="60, 110 65, 120 70, 115 75, 130 80, 125 85, 140 90, 135 95, 150 100, 145"/&gt;</pre>

<dl>
 <dt><code>points</code></dt>
 <dd>
 <p>A list of points. Each number must be separated by a space, comma, <abbr title="End of line">EOL</abbr>, or a line feed character. Each point must contain two numbers: an x coordinate and a y coordinate. So, the list <code>(0,0)</code>, <code>(1,1)</code>, and <code>(2,2)</code> would be written as <code>0, 0 1, 1 2, 2</code>.</p>
 </dd>
</dl>

<h3 id="Polygon">Polygon</h3>

<p>A {{SVGElement("polygon")}} is similar to a {{SVGElement("polyline")}}, in that it is composed of straight line segments connecting a list of points. For polygons though, the path automatically connects the last point with the first, creating a closed shape.</p>

<div class="notecard note">
<p><strong>Note:</strong> A rectangle is a type of polygon, so a polygon can be used to create a <code>&lt;rect/&gt;</code> element in cases where you need a little more flexibility.</p>
</div>

<pre class="brush:xml;gutter:false;">&lt;polygon points="50, 160 55, 180 70, 180 60, 190 65, 205 50, 195 35, 205 40, 190 30, 180 45, 180"/&gt;</pre>

<dl>
 <dt><code>points</code></dt>
 <dd>A list of points, each number separated by a space, comma, <abbr title="End of line">EOL</abbr>, or a line feed character. Each point must contain two numbers: an x coordinate and a y coordinate. So, the list <code>(0,0)</code>, <code>(1,1)</code>, and <code>(2,2)</code> would be written as <code>0, 0 1, 1 2, 2</code>. The drawing then closes the path, so a final straight line would be drawn from <code>(2,2)</code> to <code>(0,0)</code>.</dd>
</dl>

<h3 id="Path">Path</h3>

<p>A {{SVGElement("path")}} is the most general shape that can be used in SVG. Using a <code>path</code> element, you can draw rectangles (with or without rounded corners), circles, ellipses, polylines, and polygons. Basically any of the other types of shapes, bezier curves, quadratic curves, and many more.</p>

<p>For this reason, <a href="/en-US/Web/SVG/Tutorial/Paths" title="en-US/Web/SVG/Tutorial/Paths">the next section</a> in this tutorial will be focused on paths. But for now, note that there is a single parameter used to control its shape.</p>

<pre class="brush:xml;gutter:false;">&lt;path d="M20,230 Q40,205 50,230 T90,230" fill="none" stroke="blue" stroke-width="5"/&gt;</pre>

<dl>
 <dt><code>d</code></dt>
 <dd>A list of points and other information about how to draw the path. See the <a href="/en-US/Web/SVG/Tutorial/Paths" title="en-US/Web/SVG/Tutorial/Paths">Paths</a> section for more information.</dd>
</dl>

<div>{{ PreviousNext("Web/SVG/Tutorial/Positions", "Web/SVG/Tutorial/Paths") }}</div>
